Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.analysis.sinks
Class TeeSinkTokenFilter

    java.lang.Object
      org.apache.lucene.util.AttributeSource
          org.apache.lucene.analysis.TokenStream
              org.apache.lucene.analysis.TokenFilter
                  org.apache.lucene.analysis.sinks.TeeSinkTokenFilter

All Implemented Interfaces:
  Closeable

    public final class TeeSinkTokenFilter

extends TokenFilter

This TokenFilter provides the ability to set aside attribute states that have already been analyzed. This is useful in situations where multiple fields share many common analysis steps and then go their separate ways.

It is also useful for doing things like entity extraction or proper noun analysis as part of the analysis workflow and saving off those tokens for use in another field.

    TeeSinkTokenFilter source1 = new TeeSinkTokenFilter(new WhitespaceTokenizer(version, reader1));
    TeeSinkTokenFilter.SinkTokenStream sink1 = source1.newSinkTokenStream();
    TeeSinkTokenFilter.SinkTokenStream sink2 = source1.newSinkTokenStream();

    TeeSinkTokenFilter source2 = new TeeSinkTokenFilter(new WhitespaceTokenizer(version, reader2));
    source2.addSinkTokenStream(sink1);
    source2.addSinkTokenStream(sink2);

    TokenStream final1 = new LowerCaseFilter(version, source1);
    TokenStream final2 = source2;
    TokenStream final3 = new EntityDetect(sink1);
    TokenStream final4 = new URLDetect(sink2);

    d.add(new TextField("f1", final1, Field.Store.NO));
    d.add(new TextField("f2", final2, Field.Store.NO));
    d.add(new TextField("f3", final3, Field.Store.NO));
    d.add(new TextField("f4", final4, Field.Store.NO));

In this example, `sink1` and `sink2` will both get tokens from both `reader1` and `reader2` after whitespace tokenizer and now we can further wrap any of these in extra analysis, and more "sources" can be inserted if desired. It is important, that tees are consumed before sinks (in the above example, the field names must be less the sink's field names). If you are not sure, which stream is consumed first, you can simply add another sink and then pass all tokens to the sinks at once using `consumeAllTokens()`. This TokenFilter is exhausted after this. In the above example, change the example above to:

    ...
    TokenStream final1 = new LowerCaseFilter(version, source1.newSinkTokenStream());
    TokenStream final2 = source2.newSinkTokenStream();
    sink1.consumeAllTokens();
    sink2.consumeAllTokens();
    ...

In this case, the fields can be added in any order, because the sources are not used anymore and all sinks are ready.

Note, the EntityDetect and URLDetect TokenStreams are for the example and do not currently exist in Lucene.

Nested Class Summary
`static class` | `TeeSinkTokenFilter.SinkFilter` A filter that decides which `AttributeSource` states to store in the sink.
`static class` | `TeeSinkTokenFilter.SinkTokenStream` TokenStream output from a tee with optional filtering.

Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource
`AttributeSource.AttributeFactory, AttributeSource.State`

Field Summary

Fields inherited from class org.apache.lucene.analysis.TokenFilter
`input`

Constructor Summary
`TeeSinkTokenFilter(TokenStream input)` Instantiates a new TeeSinkTokenFilter.

Method Summary
`void` | `addSinkTokenStream(TeeSinkTokenFilter.SinkTokenStream sink)` Adds a `TeeSinkTokenFilter.SinkTokenStream` created by another `TeeSinkTokenFilter` to this one.
`void` | `consumeAllTokens()` `TeeSinkTokenFilter` passes all tokens to the added sinks when itself is consumed.
`void` | `end()`
`boolean` | `incrementToken()`
`TeeSinkTokenFilter.SinkTokenStream` | `newSinkTokenStream()` Returns a new `TeeSinkTokenFilter.SinkTokenStream` that receives all tokens consumed by this stream.
`TeeSinkTokenFilter.SinkTokenStream` | `newSinkTokenStream(TeeSinkTokenFilter.SinkFilter filter)` Returns a new `TeeSinkTokenFilter.SinkTokenStream` that receives all tokens consumed by this stream that pass the supplied filter.

Methods inherited from class org.apache.lucene.analysis.TokenFilter
`close, reset`

Methods inherited from class org.apache.lucene.util.AttributeSource
`addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, restoreState`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TeeSinkTokenFilter

    public TeeSinkTokenFilter(TokenStream input)

  Instantiates a new TeeSinkTokenFilter.

Method Detail

### newSinkTokenStream

    public TeeSinkTokenFilter.SinkTokenStream newSinkTokenStream()

  Returns a new `TeeSinkTokenFilter.SinkTokenStream` that receives all tokens consumed by this stream.

### newSinkTokenStream

    public TeeSinkTokenFilter.SinkTokenStream newSinkTokenStream(TeeSinkTokenFilter.SinkFilter filter)

  Returns a new `TeeSinkTokenFilter.SinkTokenStream` that receives all tokens consumed by this stream that pass the supplied filter.

  See Also:
    `TeeSinkTokenFilter.SinkFilter`

### addSinkTokenStream

    public void addSinkTokenStream(TeeSinkTokenFilter.SinkTokenStream sink)

  Adds a `TeeSinkTokenFilter.SinkTokenStream` created by another `TeeSinkTokenFilter` to this one. The supplied stream will also receive all consumed tokens. This method can be used to pass tokens from two different tees to one sink.

### consumeAllTokens

    public void consumeAllTokens()
                          throws IOException

  `TeeSinkTokenFilter` passes all tokens to the added sinks when itself is consumed. To be sure, that all tokens from the input stream are passed to the sinks, you can call this methods. This instance is exhausted after this, but all sinks are instant available.

  Throws:
    `IOException`

### incrementToken

    public boolean incrementToken()
                           throws IOException

  Specified by:
    `incrementToken` in class `TokenStream`
  Throws:
    `IOException`

### end

    public final void end()
                   throws IOException

  Overrides:
    `end` in class `TokenFilter`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.